import biosig_ext

def printf( format, *args):
	sys.stdout.write(format % args)

def sload(FILENAME):
	H=header(FILENAME)
	# print HDR
	# extracting header fields
	#H=json.loads(HDR)
	print("Loading",H["Filename"])
	Fs=H["Samplingrate"]
	dt=1000.0/Fs
	NS=len(H["CHANNEL"])
	#
	printf("SamplingRate:\t%g\n",Fs)
	printf("NumberOfChannels:\t%d\n",NS)
	print("--- channels ---\n#\tLabel\tUnits\tscaling\toffset")
	for chan in range(NS):
		printf("#%3d\t%s\t[%s]\t%g\t%g\n",chan,H["CHANNEL"][chan]["Label"],H["CHANNEL"][chan]["PhysicalUnit"],H["CHANNEL"][chan]["scaling"],H["CHANNEL"][chan]["offset"])
	### read and display data
	A = biosig.data(FILENAME)
	H["data"]=A
	#
	### read event table and extract the sweep markers ###
	# print("--- Event table ---")
	NE=1
	selpos=0
	for E in H["EVENT"]:
		# print(E)
		if (int(E["TYP"],16)==int("0x7ffe",16)):
			NE += 1;
			selpos  = np.append(selpos,int(np.around(E["POS"]*Fs)))
	#
	selpos = np.append(selpos,A.shape[0])
	H["selpos"]=selpos
	sweeplength=np.diff(selpos)
	if not all(sweeplength[0]==sweeplength):
		print('WARNING - not all sweeps have the same length')
		print(sweeplength/np.round(Fs))
	return H

#
# Load the trace from sweep, channel. 
#    sweep and channel use 1-based indexing
#
def get_trace(H, sweep, channel=0):
	if isinstance(H,str):
		H=biosig_load(H);
	selpos = H["selpos"]
	trace  = H["data"][selpos[sweep-1]:selpos[sweep]-1]
	if channel <= 0:
		return trace
	else:
		return trace[:,channel-1]

